local faction = UnitFactionGroup("player");

local frame_table = {};
frame_table.buttons = {};

function lighthouse_toggle_button()
	if lighthouseToggle == nil then
		local toggle = CreateFrame("Button", "lighthouseToggle", GarrisonShipyardFrame, "UIPanelButtonTemplate");
		toggle:SetSize(100,20);
		toggle:SetPoint("TOPRIGHT", GarrisonShipyardFrame.BorderFrame, "TOPRIGHT", -25, 0);
		toggle:SetText("Watchtower");
		toggle:SetFrameLevel(40);
		toggle:SetScript("OnClick", function(self)
			if lighthouseState == true then
				lighthouseState = false;
				lighthouseFrame();
			else
				lighthouseState = true;
				lighthouseFrame();
			end
			
		end)
	end
end


function lighthouseButtons(trait, data_frame)
	
	for index = 1, #trait do
		
		frame_table.buttons[trait[index].button_name] = CreateFrame("Button", "WT_" .. trait[index].name, data_frame);
		frame_table.buttons[trait[index].button_name]:SetNormalTexture(trait[index].icon);
		frame_table.buttons[trait[index].button_name]:SetSize(18,18);
		frame_table.buttons[trait[index].button_name]:SetPoint(trait[index].self_anchor, trait[index].relativeto, trait[index].parent_anchor, trait[index].x_offset, trait[index].y_offset);
		
		frame_table.buttons[trait[index].button_name]:SetScript("OnClick", function()
				GarrisonShipyardFrameTab2:Click();
				--GarrisonShipyardFrameFollowers.SearchBox:SetText(trait[index].name);
		end)
		frame_table[trait[index].texture_name_active]  = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_active");
		frame_table[trait[index].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
		frame_table[trait[index].texture_name_active]:SetSize(18,90);
		frame_table[trait[index].texture_name_active]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].texture_name_inactive] = frame_table.buttons[trait[index].button_name]:CreateTexture("WT_" .. trait[index].name .. "_inactive");
		frame_table[trait[index].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
		frame_table[trait[index].texture_name_inactive]:SetSize(18,90);
		frame_table[trait[index].texture_name_inactive]:SetPoint("BOTTOM", "WT_" .. trait[index].name, "TOP", 0, 7.5);
		
		frame_table[trait[index].name .. "_over"] = CreateFrame("Button", "WT_" .. trait[index].name .. "_over", data_frame);
		frame_table[trait[index].name .. "_over"]:SetNormalTexture("Interface\\PETBATTLES\\BattleBar-AbilityBadge-Strong.blp");
		frame_table[trait[index].name .. "_over"]:SetSize(15,15);
		frame_table[trait[index].name .. "_over"]:SetPoint("BOTTOM", frame_table[trait[index].texture_name_active], "TOP", 0, -1);
	end
end

function shipSync()

	local lighthouseFollowers = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
	
	ship_counter_parse(LighthouseDB.counters, lighthouseFollowers);
	ship_counter_parse(LighthouseDB.traits, lighthouseFollowers);
	ship_crew_parse(LighthouseDB.crewa, lighthouseFollowers);
	ship_crew_parse(LighthouseDB.crewh, lighthouseFollowers);
	ship_crew_parse(LighthouseDB.success_equipment, lighthouseFollowers);
	ship_crew_parse(LighthouseDB.misc_equipment, lighthouseFollowers);
	ship_crew_parse(LighthouseDB.counter_equipment, lighthouseFollowers);	
			
	lighthouseTooltips(LighthouseDB.counters);
	lighthouseTooltips(LighthouseDB.traits);
	lighthouseTooltips(LighthouseDB.success_equipment);
	lighthouseTooltips(LighthouseDB.misc_equipment);
	lighthouseTooltips(LighthouseDB.counter_equipment);
	
	if faction == "Alliance" then
		lighthouseTooltips(LighthouseDB.crewa);
	else
		lighthouseTooltips(LighthouseDB.crewh);
	end
	
end

function ship_counter_parse(traitList, my_followers)

	for key, trait in pairs(traitList) do
		
		for k in pairs (trait.active) do
			trait.active[k] = nil
		end -- for
		
		for k in pairs (trait.inactive) do
			trait.inactive[k] = nil
		end -- for
		
		
		for follower = 1, #my_followers do
			
			follower_abilities = C_Garrison.GetFollowerAbilities(my_followers[follower].followerID);
			for abilities = 1, #follower_abilities do
				ability = follower_abilities[abilities];
				
					for key, value in pairs(ability.counters) do
						if value.name == trait.name then
							
							trait.active[my_followers[follower].name] = my_followers[follower];
							
						end
					end
				
			end
		end
	end

end

function ship_crew_parse(traitList, my_followers)

	for key, trait in pairs(traitList) do
		
		for k in pairs (trait.active) do
			trait.active[k] = nil
		end -- for
		
		for k in pairs (trait.inactive) do
			trait.inactive[k] = nil
		end -- for
		
		
		for follower = 1, #my_followers do
			
			follower_abilities = C_Garrison.GetFollowerAbilities(my_followers[follower].followerID);
			for abilities = 1, #follower_abilities do
				ability = follower_abilities[abilities];
				
					if ability.name == trait.name then
						
						trait.active[my_followers[follower].name] = my_followers[follower];
						
					end
					
				
			end
		end
	end

end

function lighthouseTooltips(traits, follower_state)

	local follower_state = "active";
	
	for i =1, #traits do
	
		if follower_state == "active" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.3);
				if the_count(traits[i].active) < 1 then
					frame_table[traits[i].texture_name_active]:SetTexture(0.0,0.8,0.0,0.0);
				elseif the_count(traits[i].active) > 9 then
					frame_table[traits[i].texture_name_active]:SetSize(18, 90);
					frame_table[traits[i].name .. "_over"]:Show();
				else
					frame_table[traits[i].texture_name_active]:SetSize(18, the_count(traits[i].active) *10);
				end
			
		elseif follower_state == "inactive" then
				
				frame_table[traits[i].name .. "_over"]:Hide();
				frame_table[traits[i].texture_name_active]:SetTexture(0.8,0.0,0.0,0.0);
				frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.3);
				if the_count(traits[i].inactive) < 1 then
					frame_table[traits[i].texture_name_inactive]:SetTexture(0.8,0.0,0.0,0.0);
				elseif the_count(traits[i].inactive) > 9 then
					frame_table[traits[i].texture_name_inactive]:SetSize(18, 90);
				else
					frame_table[traits[i].texture_name_inactive]:SetSize(18, the_count(traits[i].inactive) *10);
				end
			
		end
	
		frame_table.buttons[traits[i].button_name]:SetScript("OnEnter", function(self, motion)
			GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
			if follower_state == "active" then
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].active) .. ")");
				GameTooltip:AddLine(" ");
				GameTooltip:AddLine(traits[i].description, 0, 1, 1, 1, true);
			else
				GameTooltip:SetText(traits[i].name .. "  " .. "("  .. the_count(traits[i].inactive) .. ")");
			end
			new_active = {};
			new_inactive = {};
			if follower_state == "active" then
				for key,value in pairs(traits[i].active) do
					table.insert(new_active, value);
				end
				table.sort(new_active, follower_sorting);
				if #new_active ~= 0 then
					GameTooltip:AddLine(" ");
				end
				lh_tipsy(new_active);
			else
				for key,value in pairs(traits[i].inactive) do
					table.insert(new_inactive, value);
				end
				table.sort(new_inactive, follower_sorting);
				if #new_inactive ~= 0 then
					GameTooltip:AddLine(" ");
				end
				lh_tipsy(new_inactive);
			end
			GameTooltip:Show();
		end)
		frame_table.buttons[traits[i].button_name]:SetScript("OnLeave", function(self, motion)
			GameTooltip:Hide();
		end);	
	end	
end

function lh_tipsy(tbl)
	for key, value in ipairs(tbl) do
		local status = "";
		if value.status == "Inactive" then
			status = "|cffffffff[|r" .. "|cffff0000Inactive|r" .. "|cffffffff]|r";
		else
			if value.status == nil then
				status = "|cffffffff[|r" .. "|cff1eff00Idle|r"  .. "|cffffffff]|r";
			else
				status = "|cffffffff[|r" .. "|cff1eff00" .. value.status .. "|r"  .. "|cffffffff]|r";
			end
		end
				
		if value.quality == 5 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffff8000[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status); 
			end	
		elseif value.quality == 4 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cffa335ee[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 3 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff0070dd[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		elseif value.quality == 2 then
			if value.level < 100 then
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.level .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			else
				GameTooltip:AddDoubleLine("|cff1eff00[" .. value.iLevel .. "] |r" .. "|cffffffff" .. value.name .. "|r", status);
			end
		end
	end
end